ig.module(
	'plugins.dc.background-map'
)
.requires(
	'impact.background-map'
)
.defines(function(){

ig.BackgroundMap.inject({
	init: function( tilesize, data, tileset ) {
		this.parent( tilesize, data, tileset );
		this.chunkSize = 128;
	},
    
	preRenderChunk: function( cx, cy, w, h ) {
		var tw = w / this.tilesize / ig.system.scale + 1;
			th = h / this.tilesize / ig.system.scale + 1;
		
		var nx = (cx * this.chunkSize / ig.system.scale) % this.tilesize,
			ny = (cy * this.chunkSize / ig.system.scale) % this.tilesize;
		
		var tx = Math.floor(cx * this.chunkSize / this.tilesize / ig.system.scale),
			ty = Math.floor(cy * this.chunkSize / this.tilesize / ig.system.scale);
		
		
		//console.log('about to make chunk');
		var chunk = ig.$new( 'canvas');
		console.log('chunk.id:'+chunk.id);
		chunk.width = w;
		chunk.height = h;
		
		var oldContext = ig.system.context;
		//console.log('setting ctx to chunk');
		ig.system.context = chunk.getContext("2d");
		
		for( var x = 0; x < tw; x++ ) {
			for( var y = 0; y < th; y++ ) {
				if( x + tx < this.width && y + ty < this.height ) {
					var tile = this.data[y+ty][x+tx];
					if( tile ) {
						//console.log('drawing tile');
						this.tiles.drawTile(
							x * this.tilesize - nx,	y * this.tilesize - ny,
							tile - 1, this.tilesize
						);
					}
				}
			}
		}
		//console.log('setting ctx to main ctx');
		ig.system.context = oldContext;
		
		return chunk;
	}
	
});	


});