ig.module(
	'plugins.dc.system'
)
.requires(
	'impact.system'
)
.defines(function(){


ig.System.inject({
	init: function( canvasId, fps, width, height, scale ) {
		this.fps = fps;

		this.clock = new ig.Timer();
		this.canvas = Canvas;
		this.context = this.canvas.getContext('2d');
		this.resize( width, height, scale );

		//added in impact 1.2.0
		if(ig && ig.System && ig.System.drawMode) {
			this.getDrawPos = ig.System.drawMode;
		}
	},

	oldResize: function( width, height, scale ) {
		if(AppMobi.isnative) {
			this.width = width;
			this.height = height;
	
			this.realWidth = this.width * this.scale;
			this.realHeight = this.height * this.scale;
			this.context.width = this.width;
			this.context.height = this.height;
			this.context.globalScale = scale;
			//console.log('in resize native');
		} else {
			this.parent(width, height, scale);
			//console.log('in resize else');
		}
	},	
	resize: function( width, height, scale ) {
		if(AppMobi.isnative) {
			this.context.globalScale = scale;
			this.context.width = width;
			this.context.height = height;
			
			//update height and width based on calculated values	 
			this.realWidth = this.context.width;
			this.realHeight = this.context.height;
			
			this.width = this.context.width/scale;
			this.height = this.context.height/scale;
		} else {
			this.parent(width, height, scale);
			//console.log('in resize else');
		}
	},	

	run: function() {
		this.parent();
		this.context.present();
	},
    
	getDrawPos: function(p) {
		return p;
	}
	
});


});
